Table nutrition;
Integer calT, proT, fatT, carbT;
float cal, pro, fat, carb;

float[]cals;
float[]pros;
float[]fats;
float[]carbs;
float easing;
String[]items;
String[]servings;
int counter = 1;
int count;
int cirmacro;
float targetPro; 

void setup () {
  size (displayWidth, displayHeight);  
  rectMode(CENTER);
  ellipseMode(CENTER);
  textAlign(CENTER, CENTER);
  nutrition = loadTable("nutrition.tsv"); 
  textSize (displayHeight/15);
  //orientation(LANDSCAPE);
  
  calT = 2000;
  proT = 56;
  fatT = 65;
  carbT = 275;

  count =  nutrition.getRowCount();
}

void draw() {

  String item = nutrition.getString (counter, 0);
  String serving = nutrition.getString(counter, 14);
  float target_cal  = nutrition.getFloat(counter, 1);
  float target_pro = nutrition.getFloat(counter, 2);
  float target_fat = nutrition.getFloat(counter, 3);
  float target_carb = nutrition.getFloat(counter, 5);
  int cirmacro = (displayHeight*1/5);
  float easing = 0.05;

  background(41, 128, 185,100);


  //EASINGS

  float dcal = target_cal - cal;
  if (abs(dcal) > 1) {
    cal += dcal * easing;
  }
  float dpro = target_pro - pro;
  if (abs(dpro) > 1) {
    pro += dpro * easing;
  }
  float dfat = target_fat - fat;
  if (abs(dfat) > 1) {
    fat += dfat * easing;
  }
  float dcarb = target_carb - carb;
  if (abs(dcarb) > 1) {
    carb += dcarb * easing;
  }
  //TDEE kCal circle
  stroke(0);
  fill(236, 240, 241);
  ellipse(width/8*3, height/2, height, height);

  //kCal circle
  if (cal > calT/3) {
    pushStyle();
    //stroke(0);
    //strokeWeight(8);
    fill(231, 76, 60);
    ellipse(width/8*3, height/2, height*(cal/calT)*1.3, height*(cal/calT)*1.3);
    popStyle();

    pushStyle();
    fill(52, 152, 219);
    ellipse(width/8*3, height/2, height*(cal/calT), height*(cal/calT));
    popStyle();

    //Text  
    pushStyle();
    fill(0);
    text("!", width/8*3, height/2);
    popStyle();
  }
else if 
    
   (cal > calT/4) {
    pushStyle();
    //stroke(0);
    //strokeWeight(8);
    fill(241, 196, 15);
    ellipse(width/8*3, height/2, height*(cal/calT)*1.2, height*(cal/calT)*1.2);
    popStyle();

    pushStyle();
    fill(52, 152, 219);
    ellipse(width/8*3, height/2, height*(cal/calT), height*(cal/calT));
    popStyle();

    //Text  
    pushStyle();
    fill(0);
    text("!", width/8*3, height/2);
    popStyle();
    
  } else {
    
    stroke(0);
    fill(52, 152, 219);
    ellipse(width/8*3, height/2, height*(cal/calT), height*(cal/calT));
  }

  //TDEE protein (56g = men, 18.666/g)
  stroke(0);
  fill(236, 240, 241);
  ellipse(width/10*8, height/10*2, cirmacro, cirmacro);

  //Item Protein
  if (pro > 8) {
    //outer ring
    pushStyle();
    fill(46, 204, 113);
    ellipse(width/10*8, height/10*2, cirmacro*(pro/proT)*1.2, cirmacro*(pro/proT)*1.2);
    popStyle();

    pushStyle();
    fill(155, 89, 182);
    ellipse(width/10*8, height/10*2, cirmacro*(pro/proT), cirmacro*(pro/proT));
    popStyle();

    pushStyle();
    fill(0);
    textSize(height/18);
    text("!", width/10*8, height/10*2);
    popStyle();
  } else {
    stroke(0);
    fill(155, 89, 182);
    ellipse(width/10*8, height/10*2, cirmacro*(pro/proT), cirmacro*(pro/proT));
  }

  //TDEE Fat (65g = men, 21.666/meal)
  stroke(0);
  fill(236, 240, 241);
  ellipse(width/10*8, height/10*8, cirmacro, cirmacro);

  //Item Fat

  if (fat > fatT/3) {
    pushStyle();
    fill(231, 76, 60);
    ellipse(width/10*8, height/10*8, cirmacro*(fat/fatT)*1.2, cirmacro*(fat/fatT)*1.2);
    popStyle();
    pushStyle();
    fill(230, 126, 34);
    ellipse(width/10*8, height/10*8, cirmacro*(fat/fatT), cirmacro*(fat/fatT));
    popStyle();

    pushStyle();
    fill(0);
    textSize(height/18);
    text("!", width/10*8, height/10*8); 
    popStyle();
    
  } else {
    
    stroke(0);
    fill(230, 126, 34);
    ellipse(width/10*8, height/10*8, cirmacro*(fat/fatT), cirmacro*(fat/fatT));
  }

  //TDEE Carb (275g = men, 91.666/meal)
  stroke(0);
  fill(236, 240, 241);
  ellipse(width/10*8, height/10*5, cirmacro, cirmacro);

  //Item Carb
  if (carb*4 > cal/2) {
    pushStyle();
    fill(241, 196, 15);
    ellipse(width/10*8, height/10*5, cirmacro*(carb/carbT)*1.2, cirmacro*(carb/carbT)*1.2);
    popStyle();
    
    pushStyle();
    fill(52, 152, 219);
    ellipse(width/10*8, height/10*5, cirmacro*(carb/carbT), cirmacro*(carb/carbT));
    popStyle();

    pushStyle();
    fill(0);
    textSize(height/18);
    text("!", width/10*8, height/10*5);
    popStyle();
  } else {
    stroke(0);
    fill(52, 152, 219);
    ellipse(width/10*8, height/10*5, cirmacro*(carb/carbT), cirmacro*(carb/carbT));
  }

  //item name
  fill(255);
  //rect (width/2, height/10, width/4, height/10);
  fill(0);
  text(item, width/8*3, height/11*3, width/8*2.75, height/10*3);


  //item serving
  fill(255);
  //rect (width*.8, height/2, width/5, height/10);
  fill(0);
  text(serving, width/8*3, height/11*8);
}

void mousePressed() {
   counter--;
  if (counter < 0) {
    counter = (count-1);

  }
}
void keyPressed() { 
  counter++;
  if (counter > count) {
    counter =1;
  }
}

